Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class YearMonthDurationValue

    java.lang.Object
      net.sf.saxon.value.Value<AtomicValue>
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.DurationValue
                  net.sf.saxon.value.YearMonthDurationValue

All Implemented Interfaces:
  Comparable, PullEvent, GroundedValue<AtomicValue>, Item<AtomicValue>, ValueRepresentation<AtomicValue>, ConversionResult

    public final class YearMonthDurationValue

extends DurationValue
implements Comparable

A value of type xs:yearMonthDuration

Field Summary

Fields inherited from class net.sf.saxon.value.DurationValue
`microseconds, months, negative, seconds`

Fields inherited from class net.sf.saxon.value.AtomicValue
`typeLabel`

Fields inherited from class net.sf.saxon.value.Value
`INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Method Summary
`DurationValue` | `add(DurationValue other)` Add two year-month-durations
`int` | `compareTo(Object other)` Compare the value to another duration value
`AtomicValue` | `copyAsSubType(AtomicType typeLabel)` Create a copy of this atomic value, with a different type label
`DecimalValue` | `divide(DurationValue other)` Find the ratio between two durations
`static YearMonthDurationValue` | `fromMonths(int months)` Construct a duration value as a number of months.
`int` | `getLengthInMonths()` Get the number of months in the duration
`CharSequence` | `getPrimitiveStringValue()` Convert to string
`BuiltInAtomicType` | `getPrimitiveType()` Determine the primitive type of the value.
`Object` | `getXPathComparable(boolean ordered, StringCollator collator, XPathContext context)` Get a Comparable value that implements the XPath ordering comparison semantics for this value.
`static ConversionResult` | `makeYearMonthDurationValue(CharSequence s)` Static factory: create a year-month duration value from a supplied string, in ISO 8601 format [+|-]PnYnM
`DurationValue` | `multiply(double n)` Multiply duration by a number.
`DurationValue` | `negate()` Negate a duration (same as subtracting from zero, but it preserves the type of the original duration)
`DurationValue` | `subtract(DurationValue other)` Subtract two year-month-durations

Methods inherited from class net.sf.saxon.value.DurationValue
`badDuration, equals, getComponent, getDays, getHours, getLengthInSeconds, getMicroseconds, getMinutes, getMonths, getSchemaComparable, getSchemaComparable, getSeconds, getTotalMonths, getTotalSeconds, getYears, hashCode, makeDuration, makeDuration, normalizeDuration, normalizeZeroDuration, signum, simpleInteger`

Methods inherited from class net.sf.saxon.value.AtomicValue
`asAtomic, checkPermittedContents, effectiveBooleanValue, getCardinality, getItemType, getLength, getStringValue, getStringValueCS, getTypedValue, getTypeLabel, isIdentical, isNaN, itemAt, iterate, process, setTypeLabel, subsequence, toString`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, convertToJava, fromItem, getCanonicalLexicalRepresentation, getIterator, getSequenceLength, reduce`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### makeYearMonthDurationValue

    public static ConversionResult makeYearMonthDurationValue(CharSequence s)

  Static factory: create a year-month duration value from a supplied string, in ISO 8601 format [+|-]PnYnM

  Parameters:
    `s` - a string in the lexical space of xs:yearMonthDuration.
  Returns:
    either a YearMonthDurationValue, or a ValidationFailure if the string was not in the lexical space of xs:yearMonthDuration.

### copyAsSubType

    public AtomicValue copyAsSubType(AtomicType typeLabel)

  Create a copy of this atomic value, with a different type label

  Overrides:
    `copyAsSubType` in class `DurationValue`
  Parameters:
    `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.
  Returns:
    the copied value

### getPrimitiveType

    public BuiltInAtomicType getPrimitiveType()

  Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.

  Overrides:
    `getPrimitiveType` in class `DurationValue`
  Returns:
    the primitive type

### getPrimitiveStringValue

    public CharSequence getPrimitiveStringValue()

  Convert to string

  Overrides:
    `getPrimitiveStringValue` in class `DurationValue`
  Returns:
    ISO 8601 representation.

### getLengthInMonths

    public int getLengthInMonths()

  Get the number of months in the duration

  Returns:
    the number of months in the duration

### fromMonths

    public static YearMonthDurationValue fromMonths(int months)

  Construct a duration value as a number of months.

  Parameters:
    `months` - the number of months (may be negative)
  Returns:
    the corresponding xs:yearMonthDuration value

### multiply

    public DurationValue multiply(double n)
                           throws XPathException

  Multiply duration by a number. Also used when dividing a duration by a number

  Overrides:
    `multiply` in class `DurationValue`
  Parameters:
    `n` - the number to multiply by
  Returns:
    the result of the multiplication
  Throws:
    `XPathException`

### divide

    public DecimalValue divide(DurationValue other)
                        throws XPathException

  Find the ratio between two durations

  Overrides:
    `divide` in class `DurationValue`
  Parameters:
    `other` - the dividend
  Returns:
    the ratio, as a decimal
  Throws:
    `XPathException`

### add

    public DurationValue add(DurationValue other)
                      throws XPathException

  Add two year-month-durations

  Overrides:
    `add` in class `DurationValue`
  Parameters:
    `other` - the duration to be added to this one
  Returns:
    the sum of the two durations
  Throws:
    `XPathException`

### subtract

    public DurationValue subtract(DurationValue other)
                           throws XPathException

  Subtract two year-month-durations

  Overrides:
    `subtract` in class `DurationValue`
  Parameters:
    `other` - the duration to be subtracted from this one
  Returns:
    the difference of the two durations
  Throws:
    `XPathException`

### negate

    public DurationValue negate()

  Negate a duration (same as subtracting from zero, but it preserves the type of the original duration)

  Overrides:
    `negate` in class `DurationValue`
  Returns:
    the original duration with its sign reversed, retaining its type

### compareTo

    public int compareTo(Object other)

  Compare the value to another duration value

  Specified by:
    `compareTo` in interface `Comparable`
  Parameters:
    `other` - The other dateTime value
  Returns:
    negative value if this one is the earler, 0 if they are chronologically equal, positive value if this one is the later. For this purpose, dateTime values with an unknown timezone are considered to be UTC values (the Comparable interface requires a total ordering).
  Throws:
    `ClassCastException` - if the other value is not a DateTimeValue (the parameter is declared as Object to satisfy the Comparable interface)

### getXPathComparable

    public Object getXPathComparable(boolean ordered,
                                     StringCollator collator,
                                     XPathContext context)

  Get a Comparable value that implements the XPath ordering comparison semantics for this value. Returns null if the value is not comparable according to XPath rules. The default implementation returns the value itself. This is modified for types such as xs:duration which allow ordering comparisons in XML Schema, but not in XPath.

  Overrides:
    `getXPathComparable` in class `DurationValue`
  Parameters:
    `ordered` -
    `collator` -
    `context` -
  Returns:
    an Object whose equals() and hashCode() methods implement the XPath comparison semantics with respect to this atomic value. If ordered is specified, the result will either be null if no ordering is defined, or will be a Comparable

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.